# The Interval of Summations Abstraction for Parallel Prefix Sums

This repository implements two OpenCL experiments for showing the effectiveness of the Interval of Summations Abstraction.
We implement the interval of abstractions as a simple set of preprocessor macros and the quadratic Voigtlaender method.
These are the programs `atester` and `vtester` that are built inside the `src` directory.

## Prerequisites

* Python 2.73

* OpenCL 1.0 or greater

## Build instructions

* Inside a *bash* shell set the environment variable `CLDIR` to point to your installation of the OpenCL SDK.
  This should be the base directory from which `lib` and `include` can be found.
  Export the variable like this:

```
export CLDIR=/path/to/opencl/installation
```

* Now execute the build script:

```
./build.sh
```

* This should automatically build the OpenCL wrapper library `lib/libOpenCL.so` and two programs, `atester` and `vtester`, in the `src` directory.

## Running the testers directly 

Each tester is invoked with the number of elements to perform the prefix sum and the chosen prefix sum algorithm. For example:

```
./atester 16 sklansky.cl
```

Invokes the abstract tester for the Sklansky algorithm over a 16 element-wide array.

## Running the experiments

```
* Run the experiment script:

```
./run_experiments.py | tee results.csv
```

* This will generate a `result.csv` file.
